package org.ssssssss.magicboot.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.xxl.job.core.context.XxlJobHelper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.ssssssss.magicboot.constant.ERPURLConstant;
import org.ssssssss.magicboot.fxapi.HttpClientResult;
import org.ssssssss.magicboot.fxapi.HttpClientUtils;
import org.ssssssss.magicboot.fxapi.XKTokenAccess;
import org.ssssssss.magicboot.fxapi.model.CrmFXApiParam;
import org.ssssssss.magicboot.zdyutils.FXHTTP;
import org.ssssssss.magicboot.zdyutils.GcjJson;
import org.ssssssss.magicboot.zdyutils.MagicApi;

import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/ProjectNewOpportunity")
public class ProjectNewOpportunityController {
    static Logger log = LoggerFactory.getLogger("ProjectNewOpportunity");

    public static void main(String[] args) throws Exception {
            new ProjectNewOpportunityController().getSynData();
            new ProjectNewOpportunityController().saveSynData();

    }

    public void getSynData() throws Exception {
        FXHTTP fxapi = new FXHTTP();
        XKTokenAccess xktonken = new XKTokenAccess();
        // 查询magic接口
        //获取时间戳
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String time = sdf.format(System.currentTimeMillis() - (1000 * 60 * 60));

        String apiName = "NewOpportunityObj";

        List<CrmFXApiParam> paramList = Arrays.asList(
                new CrmFXApiParam("GT", "create_time", "1748923200000"),
                new CrmFXApiParam("GT", "last_modified_time", System.currentTimeMillis() - (1000 * 60 * 60 * 24)),
                new CrmFXApiParam("IS", "erp_id__c", ""),
                new CrmFXApiParam("EQ", "sync_status__c", "option_pending_sync__c"),
                new CrmFXApiParam("EQ", "life_status", "normal")
        );

           //List<CrmFXApiParam> paramList = Arrays.asList(new CrmFXApiParam("EQ", "name",  "溧阳大溪水库低空智能巡检建设项目-水利测试"));

        JSONObject jsonject = fxapi.getSynNewDataObj(false, "商机", apiName, paramList);
        JSONArray array = jsonject.getJSONObject("data").getJSONArray("dataList");
        List<CrmFXApiParam> paramListB = Arrays.asList(
                new CrmFXApiParam("EQ", "sync_status__c", "option_resync__c"),
                new CrmFXApiParam("EQ", "life_status", "normal")
        );
        JSONObject jsonjectB = fxapi.getSynNewDataObj(false, "商机重新同步", apiName, paramListB);
        JSONArray arrayA = jsonjectB.getJSONObject("data").getJSONArray("dataList");
        array.addAll(arrayA);

        for (int i = 0; i < array.size(); i++) {
            JSONObject str = array.getJSONObject(i);
            String dataId = GcjJson.getNodeValue(str,  "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
            String nameData = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";
            String status = GcjJson.getNodeValue(str, "JSON.sync_status__c") != null ? GcjJson.getNodeValue(str, "JSON.sync_status__c").toString() : "";
            String endtime = GcjJson.getNodeValue(str, "JSON.last_modified_time") != null ? GcjJson.getNodeValue(str, "JSON.last_modified_time").toString() : "";

            String syn_type = "0";//同步类型 0新增 1修改 2删除
            log.info("-------------------开始执行项目（商机）" + i + " -------------------" + nameData);
            XxlJobHelper.log("-------------------开始执行项目（商机）" + i + " -------------------" + nameData);

            Boolean sendFlag = false;
            StringBuffer stringBuffer = new StringBuffer();

            try {
                boolean tbflag = false;
                //验证数据是否已存在
                JSONObject dataSyn = MagicApi.getSendSYNDataProject("SJ", syn_type, dataId);

                if (dataSyn != null && dataId.equals(dataSyn.getString("crmId"))) {
                    log.info("数据已存在-" + nameData);
                    XxlJobHelper.log("--数据已存在---" + nameData);
                    tbflag = true;
                    if("option_resync__c".equals(status) && !endtime.equals(dataSyn.getString("mark"))){
                        tbflag = false;
                    }
                }
                if (tbflag) {
                    continue;
                }
                log.info("客户待同步数据-" + i + " ------" + nameData);
                JSONObject jsonObjectData = new JSONObject();
                jsonObjectData.put("send_type", "SJ"); //业务类型
                jsonObjectData.put("send_syn", "0"); //同步类型 0新增 1修改 2删除
                jsonObjectData.put("crm_id", dataId);//数据id
                jsonObjectData.put("crmzhu_id", dataId);//数据id
                jsonObjectData.put("send_status", 3);//同步状态 true同步成功 false同步失败 3待同步
                jsonObjectData.put("crm_code", nameData);//数据名称
                jsonObjectData.put("mark", endtime);//标识
                jsonObjectData.put("crm_json", str.toJSONString());//标识

                MagicApi.saveSendSYNDataProject(jsonObjectData);
            } catch (Exception e) {
                continue;
            }

        }
    }

    public void saveSynData() throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
        FXHTTP fxapi = new FXHTTP();
        String resJsonStr = MagicApi.getWNRES("http://localhost:18088/syn/queryProject?sendType=SJ&sendStatus=3&sendSyn=0", "");
        JSONObject resJson = JSON.parseObject(resJsonStr);
        if (resJson != null) {
            log.info("待同步项目（商机）数" + resJson.getJSONArray("data").size());
            for (int i = 0; i < resJson.getJSONArray("data").size(); i++) {

                JSONObject getData = resJson.getJSONArray("data").getJSONObject(i);
                JSONObject str = getData.getJSONObject("crmJson");
                String syn_type = "0";//同步类型 0新增 1修改 2删除
                Boolean sendFlag = false;
                StringBuffer stringBuffer = new StringBuffer();
                boolean tbflag = false;
                // 构建json

                String dataId = GcjJson.getNodeValue(str, "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
                String nameData = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";
                String number = GcjJson.getNodeValue(str, "JSON.opportunity_id__c") != null ? GcjJson.getNodeValue(str, "JSON.opportunity_id__c").toString() : "";
                String status = GcjJson.getNodeValue(str, "JSON.sync_status__c") != null ? GcjJson.getNodeValue(str, "JSON.sync_status__c").toString() : "";
                String endtime = GcjJson.getNodeValue(str, "JSON.last_modified_time") != null ? GcjJson.getNodeValue(str, "JSON.last_modified_time").toString() : "";


                String org = GcjJson.getNodeValue(str, "JSON.erp_organization__c") != null ? GcjJson.getNodeValue(str, "JSON.erp_organization__c").toString() : "";

                String strJson = "";
                try{
                    JSONObject dataSyn = MagicApi.getSendSYNDataProject("SJ", syn_type, dataId,"3");
                    if (dataSyn != null && dataId.equals(dataSyn.getString("crmId"))) {
                        log.info("数据已存在-" + nameData);
                        XxlJobHelper.log("--数据已存在---" + nameData);
                        tbflag = true;
                        if("option_resync__c".equals(status) && !endtime.equals(dataSyn.getString("mark"))){
                            tbflag = false;
                        }
                    }
                    if (tbflag) {
                        continue;
                    }

                    JSONObject params = new JSONObject();

                    JSONArray dataarr = new JSONArray();
                    JSONObject datajson = new JSONObject();

                    //编码
                    datajson.put("number",number);
                    datajson.put("group_number","XM_03");//项目分类
                    datajson.put("name",nameData);//项目名称
                    datajson.put("f9w5_crmid",dataId);//CRMID
                    datajson.put("enable","1");//使用状态
                    datajson.put("status","C");//数据状态
                    //创建组织
                    datajson.put("createorg_number",org);
                    dataarr.add(datajson);
                    params.put("data",dataarr);
                    log.info("--请求json---" + params.toJSONString());
                    System.out.println("--请求json:---" +params.toJSONString());
                    strJson = params.toJSONString();

                }catch  (Exception e) {
                    sendFlag = true;
                    stringBuffer.append("参数解析错误，请联系开发人员");
                    e.printStackTrace();
                }
                getSynDataSave(stringBuffer,sendFlag,fxapi,dataId,nameData,strJson,getData);

            }
        }
    }
    /**
     * 写数据
     */
    public void getSynDataSave(StringBuffer stringBuffer,Boolean sendFlag,FXHTTP fxapi,String dataId,String nameData,String obj,JSONObject str) {
        String syn_type = "0";//同步类型 0新增 1修改 2删除
        String res_url = ERPURLConstant.ERP_URL + "/ierp/kapi/v2/f9w5/basedata/bd_project/projectSave";
        String res_param = obj;
        String res = "";
        try {
            //String accessToken = "2096108315279888384_hjuaG4aAhb6aY7DOaoUmDLzx4lBXY3q4q5n7PvEVsq740PNMWx1X1q4CD1wljgW33pj5Ie8lbXCG3a2CIDFgxqGrmo2TCg5ss6kY03";
            String accessToken = new KDTokenController().getKDAccessTokenTest();


            Map<String, String> headers = new HashMap<String, String>();
            headers.put("accessToken",  accessToken);//放token
            HttpClientResult rtn = HttpClientUtils.doPostJson(res_url, headers, obj);
            String resStr =  rtn.getContent();
            JSONObject resjs = JSONObject.parseObject(resStr);
            res = resStr;
            if (resjs != null && resjs.getBoolean("status")) {
                JSONObject successdata  =  resjs.getJSONObject("data");
                JSONArray result = successdata.getJSONArray("result");
                JSONObject erpdata = (JSONObject) result.get(0);
                String erpid = erpdata.getString("id");

                Map<String, Object> paramMap = new HashMap<String, Object>();
                paramMap.put("erp_id__c", erpid);//数据ID
                paramMap.put("sync_status__c", "option_sync_success__c");
                paramMap.put("sync_info__c", resjs.getString("message"));
                //回写json
                fxapi.upSynFieldParam("", "NewOpportunityObj", dataId, paramMap);
            }else{
                sendFlag=true;
                stringBuffer.append("项目创建接口调用失败:"+resjs.getString("message"));
                Map<String, Object> paramMap = new HashMap<String, Object>();
                paramMap.put("sync_status__c", "option_sync_failure__c");
                paramMap.put("sync_info__c", stringBuffer);
                //回写json
                fxapi.upSynFieldParam("", "NewOpportunityObj", dataId, paramMap);
            }
        } catch (Exception e) {
            sendFlag = true;
            stringBuffer.append("项目创建接口调用失败,请检查网络配置");
            Map<String, Object> paramMap = new HashMap<String, Object>();
            paramMap.put("sync_status__c", "option_sync_failure__c");
            paramMap.put("sync_info__c", stringBuffer);
            //回写json
            fxapi.upSynFieldParam("", "NewOpportunityObj", dataId, paramMap);
        }

        JSONObject sendData = new JSONObject();

        sendData.put("send_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步

        sendData.put("send_id", str.getString("sendId")); //send_id
        MagicApi.updateSendSYUPDATEProject(sendData);

        JSONObject logData = new JSONObject();
        logData.put("log_type", "SJ"); //业务类型
        logData.put("log_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步
        logData.put("syn_type", syn_type);//同步类型 0新增 1修改 2删除
        logData.put("data_id", dataId);//数据id
        logData.put("data_name", nameData);//数据名称
        logData.put("res_body", "同步成功");//返回值
        logData.put("res_url", res_url);//
        logData.put("res_param", res_param);//
        logData.put("res_res", res);//
        if (sendFlag) {
            logData.put("res_body", stringBuffer.toString());//返回值
        }
        //写入传输日志
        MagicApi.saveProjectLog(logData);
    }


    public void getSynDataUP() throws Exception {
        FXHTTP fxapi = new FXHTTP();
        XKTokenAccess xktonken = new XKTokenAccess();
        // 查询magic接口
        //获取时间戳
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String time = sdf.format(System.currentTimeMillis() - (1000 * 60 * 60));

        String apiName = "NewOpportunityObj";

        List<CrmFXApiParam> paramList = Arrays.asList(
                new CrmFXApiParam("GT", "last_modified_time", System.currentTimeMillis() - (1000 * 60 * 60 * 24)),
                new CrmFXApiParam("ISN", "erp_id__c", ""),
                new CrmFXApiParam("EQ", "life_status", "invalid")
        );


      /*  List<CrmFXApiParam> paramList = Arrays.asList(new CrmFXApiParam("EQ", "name", "华润新能源（禹城）风力发电场项目"));
*/
        JSONObject jsonject = fxapi.getSynNewDataObj(false, "商机", apiName, paramList);
        JSONArray array = jsonject.getJSONObject("data").getJSONArray("dataList");


        for (int i = 0; i < array.size(); i++) {
            JSONObject str = array.getJSONObject(i);
            String dataId = GcjJson.getNodeValue(str,  "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
            String nameData = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";

            String syn_type = "1";//同步类型 0新增 1修改 2删除
            log.info("-------------------开始执行项目（商机）" + i + " -------------------" + nameData);
            XxlJobHelper.log("-------------------开始执行项目（商机）" + i + " -------------------" + nameData);

            Boolean sendFlag = false;
            StringBuffer stringBuffer = new StringBuffer();

            try {
                boolean tbflag = false;
                //验证数据是否已存在
                JSONObject dataSyn = MagicApi.getSendSYNDataProject("SJUP", syn_type, dataId);

                if (dataSyn != null && dataId.equals(dataSyn.getString("crmId"))) {
                    log.info("数据已存在-" + nameData);
                    XxlJobHelper.log("--数据已存在---" + nameData);
                    tbflag = true;
                }
                if (tbflag) {
                    continue;
                }
                log.info("客户待同步数据-" + i + " ------" + nameData);
                JSONObject jsonObjectData = new JSONObject();
                jsonObjectData.put("send_type", "SJUP"); //业务类型
                jsonObjectData.put("send_syn", "1"); //同步类型 0新增 1修改 2删除
                jsonObjectData.put("crm_id", dataId);//数据id
                jsonObjectData.put("crmzhu_id", dataId);//数据id
                jsonObjectData.put("send_status", 3);//同步状态 true同步成功 false同步失败 3待同步
                jsonObjectData.put("crm_code", nameData);//数据名称
                jsonObjectData.put("mark", nameData);//标识
                jsonObjectData.put("crm_json", str.toJSONString());//标识

                MagicApi.saveSendSYNDataProject(jsonObjectData);
            } catch (Exception e) {
                continue;
            }

        }
    }
    public void updateSynData() throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
        FXHTTP fxapi = new FXHTTP();
        String resJsonStr = MagicApi.getWNRES("http://localhost:18088/syn/queryProject?sendType=SJUP&sendStatus=3&sendSyn=1", "");
        JSONObject resJson = JSON.parseObject(resJsonStr);
        if (resJson != null) {
            log.info("待同步项目（商机）数" + resJson.getJSONArray("data").size());
            for (int i = 0; i < resJson.getJSONArray("data").size(); i++) {

                JSONObject getData = resJson.getJSONArray("data").getJSONObject(i);
                JSONObject str = getData.getJSONObject("crmJson");
                String syn_type = "1";//同步类型 0新增 1修改 2删除
                Boolean sendFlag = false;
                StringBuffer stringBuffer = new StringBuffer();
                boolean tbflag = false;
                // 构建json

                String dataId = GcjJson.getNodeValue(str, "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
                String nameData = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";
                String number = GcjJson.getNodeValue(str, "JSON.opportunity_id__c") != null ? GcjJson.getNodeValue(str, "JSON.opportunity_id__c").toString() : "";

                String strJson = "";
                try{
                    JSONObject dataSyn = MagicApi.getSendSYNDataProject("SJUP", syn_type, dataId,"3");
                    if (dataSyn != null && dataId.equals(dataSyn.getString("crmId"))) {
                        log.info("数据已存在-" + nameData);
                        XxlJobHelper.log("--数据已存在---" + nameData);
                        tbflag = true;
                    }
                    if (tbflag) {
                        continue;
                    }

                    JSONObject params = new JSONObject();

                    JSONArray dataarr = new JSONArray();
                    JSONObject datajson = new JSONObject();

                    //编码
                    datajson.put("number",number);
                    datajson.put("group_number","01");//项目分类
                    datajson.put("name",nameData);//项目名称
                    datajson.put("f9w5_crmid",dataId);//CRMID
                    datajson.put("enable","2");//使用状态   禁用
                    datajson.put("status","C");//数据状态
                    //创建组织
                    datajson.put("createorg_number","zyierp");
                    dataarr.add(datajson);
                    params.put("data",dataarr);
                    log.info("--请求json---" + params.toJSONString());
                    System.out.println("--请求json:---" +params.toJSONString());
                    strJson = params.toJSONString();

                }catch  (Exception e) {
                    sendFlag = true;
                    stringBuffer.append("参数解析错误，请联系开发人员");
                    e.printStackTrace();
                }
                getSynDataSaveUP(stringBuffer,sendFlag,fxapi,dataId,nameData,strJson,getData);

            }
        }
    }
    public void getSynDataSaveUP(StringBuffer stringBuffer,Boolean sendFlag,FXHTTP fxapi,String dataId,String nameData,String obj,JSONObject str) {
        String syn_type = "1";//同步类型 0新增 1修改 2删除
        String res_url = ERPURLConstant.ERP_URL + "/ierp/kapi/v2/f9w5/basedata/bd_project/projectSave";
        String res_param = obj;
        String res = "";
        try {
            String accessToken = "2096108315279888384_hjuaG4aAhb6aY7DOaoUmDLzx4lBXY3q4q5n7PvEVsq740PNMWx1X1q4CD1wljgW33pj5Ie8lbXCG3a2CIDFgxqGrmo2TCg5ss6kY03";
            //  String accessToken = new KDTokenController().getKDAccessToken();


            Map<String, String> headers = new HashMap<String, String>();
            headers.put("accessToken",  accessToken);//放token
            HttpClientResult rtn = HttpClientUtils.doPostJson(res_url, headers, obj);
            String resStr =  rtn.getContent();
            JSONObject resjs = JSONObject.parseObject(resStr);
            res = resStr;
            if (resjs != null && resjs.getBoolean("status")) {
                JSONObject successdata  =  resjs.getJSONObject("data");
                JSONArray result = successdata.getJSONArray("result");
                JSONObject erpdata = (JSONObject) result.get(0);
                String erpid = erpdata.getString("id");
                Map<String, Object> paramMap = new HashMap<String, Object>();
                paramMap.put("sync_info__c", resjs.getString("message"));
                //回写json
                fxapi.upSynFieldParam("", "NewOpportunityObj", dataId, paramMap);
            }else{
                sendFlag=true;
                stringBuffer.append("项目作废接口调用失败:"+resjs.getString("message"));
                Map<String, Object> paramMap = new HashMap<String, Object>();
                paramMap.put("sync_status__c", "option_sync_failure__c");
                paramMap.put("sync_info__c", stringBuffer);
                //回写json
                fxapi.upSynFieldParam("", "NewOpportunityObj", dataId, paramMap);
            }
        } catch (Exception e) {
            sendFlag = true;
            stringBuffer.append("项目作废接口调用失败,请检查网络配置");
            Map<String, Object> paramMap = new HashMap<String, Object>();
            paramMap.put("sync_status__c", "option_sync_failure__c");
            paramMap.put("sync_info__c", stringBuffer);
            //回写json
            fxapi.upSynFieldParam("", "NewOpportunityObj", dataId, paramMap);
        }

        JSONObject sendData = new JSONObject();

        sendData.put("send_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步

        sendData.put("send_id", str.getString("sendId")); //send_id
        MagicApi.updateSendSYUPDATEProject(sendData);

        JSONObject logData = new JSONObject();
        logData.put("log_type", "SJUP"); //业务类型
        logData.put("log_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步
        logData.put("syn_type", syn_type);//同步类型 0新增 1修改 2删除
        logData.put("data_id", dataId);//数据id
        logData.put("data_name", nameData);//数据名称
        logData.put("res_body", "同步成功");//返回值
        logData.put("res_url", res_url);//
        logData.put("res_param", res_param);//
        logData.put("res_res", res);//
        if (sendFlag) {
            logData.put("res_body", stringBuffer.toString());//返回值
        }
        //写入传输日志
        MagicApi.saveProjectLog(logData);
    }

    }
