package org.ssssssss.magicboot.fxapi;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.ssssssss.magicboot.fxapi.model.AppAccessToken;
import org.ssssssss.magicboot.fxapi.model.CorpAccessToken;
import org.ssssssss.magicboot.fxapi.model.XKopenAPI;

import java.util.HashMap;
import java.util.Map;

/**
 * 纷享请求token
 */
public class XKTokenAccess {
    /**
     * 验证连接
     */
    public static void main(String[] args) {
        System.out.println(new XKTokenAccess().getCorpAccessToken());
    }
    private final Logger log = LoggerFactory.getLogger(XKTokenAccess.class);


    private static final String KEY_EXPIRES_IN = "expiresIn";
    private static final String KEY_TOKEN = "token";
    private static final String APP_ACCESS_TOKEN_KEY_PREX = "appAccessToken_";
    private static final String CORP_ACCESS_TOKEN_KEY_PREX = "corpAccessToken_";

    private static final String appId = "FSAID_131f56a";
    private static final String appSecret= "5bda722932a54e80a05d2cc9b1722fed";
    private static final String permanentCode= "1A49B50861909007935CAB5E33E52BAA";

    private static final String prefix = "https://open.fxiaoke.com";

    private static Map<String,Map<String, Object>>  accessTokenMap= new HashMap();

    public static Map<String,Map<String, Object>> accessTokenMap() {
        return accessTokenMap;
    }

    public AppAccessToken getAppAccessToken() {
        String key = APP_ACCESS_TOKEN_KEY_PREX.concat(appId);
        Map<String, Object> token = accessTokenMap.get(key);
        if(token != null){
            long expiresIn = (Long) token.get(KEY_EXPIRES_IN);

            if (System.currentTimeMillis() < expiresIn) {
                return (AppAccessToken) token.get(KEY_TOKEN);
            }
            accessTokenMap.remove(key);
        }
        String appAccessToken = null;
        XKopenAPI XKAPI = new XKopenAPI();
        XKAPI.setAppId(appId);
        XKAPI.setAppSecret(appSecret);
        String param = JSON.toJSONString(XKAPI);

        AppAccessToken appToken =null;
        try {
            String url = prefix + "/cgi/appAccessToken/get";
            HttpClientResult result = HttpClientUtils.doPostJson(url,param);
            appToken = JSON.toJavaObject(JSONObject.parseObject(result.getContent()),AppAccessToken.class);
        } catch (Exception e) {
            e.printStackTrace();
        }
        token = new HashMap();
        // 减去5分钟，以免过时
        token.put(KEY_EXPIRES_IN, (appToken.getExpiresIn() - 5 * 60) * 1000 + System.currentTimeMillis());
        token.put(KEY_TOKEN, appAccessToken);
        accessTokenMap.put(key, token);
        return appToken;
    }

    public CorpAccessToken getCorpAccessToken() {
        String key = CORP_ACCESS_TOKEN_KEY_PREX.concat(appId);
        Map<String, Object> token = accessTokenMap.get(key);
        if(token != null){
            long expiresIn = (Long) token.get(KEY_EXPIRES_IN);

            if (System.currentTimeMillis() < expiresIn) {
                return (CorpAccessToken) token.get(KEY_TOKEN);
            }
            accessTokenMap.remove(key);
        }
        String corpAccessToken = null;
        XKopenAPI XKAPI = new XKopenAPI();
        XKAPI.setAppId(appId);
        XKAPI.setAppSecret(appSecret);
        XKAPI.setPermanentCode(permanentCode);
        String param = JSON.toJSONString(XKAPI);
        CorpAccessToken corpToken =null;

        try {
            String url = prefix + "/cgi/corpAccessToken/get/V2";
            HttpClientResult result = HttpClientUtils.doPostJson(url,param);
            System.out.println(result);
            corpToken = JSON.toJavaObject(JSONObject.parseObject(result.getContent()),CorpAccessToken.class);
        } catch (Exception e) {
            e.printStackTrace();
        }
        token = new HashMap();
        // 减去5分钟，以免过时
        token.put(KEY_EXPIRES_IN, (corpToken.getExpiresIn() - 5 * 60) * 1000 + System.currentTimeMillis());
        token.put(KEY_TOKEN, corpToken);
        accessTokenMap.put(key, token);
        return corpToken;
    }
}
