package org.ssssssss.magicboot.task;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.ssssssss.magicboot.controller.UsceController;
import org.ssssssss.magicboot.controller.customerContactController;
import org.ssssssss.magicboot.controller.customerController;
import org.ssssssss.magicboot.controller.customerFinInfoController;

import java.time.LocalDateTime;

@Configuration      //1.主要用于标记配置类，兼备Component的效果。
@EnableScheduling   // 2.开启定时任务
public class testTask {
    @Autowired
    UsceController user;

    @Autowired
    customerController customer;
    @Autowired
    customerContactController contact;
    @Autowired
    customerFinInfoController finInfo;

    @Scheduled(cron = "0 */1 * * * ?")
    //或直接指定时间间隔，例如：5秒
    private void configureTasks() throws Exception {
        customer.getSynDataAdd();
        customer.getSynKH();
        customer.getSynDataUpdate();
        customer.getSynKHUPdate();

        System.err.println("执行静态定时任务时间: " + LocalDateTime.now());
    }

    @Scheduled(cron = "0 */2 * * * ?")
    //或直接指定时间间隔，例如：5秒
    private void configureTasks2() throws Exception {
        contact.getSynDataAdd();
        contact.SaveSyn();
        finInfo.getSynDataAdd();
        finInfo.SaveSyn();

        System.err.println("执行2静态定时任务时间: " + LocalDateTime.now());
    }

    @Scheduled(cron = "0 */30 * * * ?")
    //或直接指定时间间隔，例如：5秒
    private void configureTasks30() throws Exception {
        user.getUserData();
        user.saveSynUser();
        System.err.println("执行30静态定时任务时间: " + LocalDateTime.now());
    }
}
