package org.ssssssss.magicboot.zdyutils;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.ssssssss.magicboot.fxapi.HttpClientResult;
import org.ssssssss.magicboot.fxapi.HttpClientUtils;

import org.ssssssss.magicboot.fxapi.model.CorpAccessToken;
import org.ssssssss.magicboot.fxapi.model.XKopenAPI;
import org.ssssssss.magicboot.model.CorpAccessU9Token;


import java.util.HashMap;
import java.util.Map;

/**
 * u9请求token
 */
public class U9TokenAccess {
    /**
     * 验证连接
     */
    public static void main(String[] args) {
        System.out.println(new U9TokenAccess().getCorpAccessU9Token());
    }
    private final Logger log = LoggerFactory.getLogger(U9TokenAccess.class);

    private static final String KEY_TOKEN = "token";
    private static final String clientid = "crm";

   //测试
  //  private static final String clientsecret = "00dcb146d019426f9ccf6889c6d26624";

    private static final String clientsecret = "765f536b447e4960b0bcc07851e87936"; //正式

    private static final String entCode = "03";
    private static final String userCode = "admin";
    private static final String orgCode = "01";
    private static final String CORP_ACCESS_TOKEN_KEY_PREX = "corpAccessU9Token_";
    private static final String KEY_EXPIRES_IN = "expiresIn";

   // private static final String prefix = "http://60.211.244.254:9111/U9C/webapi/OAuth2/AuthLogin";//测试

    private static final String prefix = "http://192.168.1.21/U9C/webapi/OAuth2/AuthLogin";

    private static Map<String,Map<String, Object>>  accessTokenMap= new HashMap();

    public static Map<String,Map<String, Object>> accessTokenMap() {
        return accessTokenMap;
    }

    public CorpAccessU9Token getCorpAccessU9Token() {
        String key = CORP_ACCESS_TOKEN_KEY_PREX;
        Map<String, Object> token = accessTokenMap.get(key);
        if(token != null){
            long expiresIn = (Long) token.get(KEY_EXPIRES_IN);

            if (System.currentTimeMillis() < expiresIn) {
                return (CorpAccessU9Token) token.get(KEY_TOKEN);
            }
            accessTokenMap.remove(key);
        }
        Map<String, String> map = new HashMap<>();
        map.put("clientid",clientid);
        map.put("clientsecret",clientsecret);
        map.put("entCode",entCode);
        map.put("userCode",userCode);
        map.put("orgCode",orgCode);
       // String param = JSON.toJSONString(map);
        CorpAccessU9Token corpToken =null;

        try {
            String url = prefix;
            HttpClientResult result = HttpClientUtils.doGet(url,map);
            System.out.println(result);
            corpToken = JSON.toJavaObject(JSONObject.parseObject(result.getContent()),CorpAccessU9Token.class);
        } catch (Exception e) {
            e.printStackTrace();
        }
        token = new HashMap();
        // 减去10分钟，以免过时
        token.put(KEY_EXPIRES_IN, (300 - 60) * 1000 + System.currentTimeMillis());
        if (corpToken != null) {
            token.put(KEY_TOKEN, corpToken);
        }
        accessTokenMap.put(key, token);
        return corpToken;
    }
}
